package provide TDShock 1.0

# THIS procedure puts up the colorbar and annotates it.
#
#  OUTPUT:   cInfo: the color conversion parameters 
 
proc CBarUp { cInfo } {
   global GphInfo tdsANS

   upvar $cInfo cA

# DETERMINE the color bar labeling format to use

   if [string match LINEAR $tdsANS(cSca)] {
      set nFmt "%.0f"
   } else {
      set nFmt expon
   }

# STANDARD color bar options.  Mod them below

   set cInputs(pMIN)      $tdsANS(cMin)
   set cInputs(pMAX)      $tdsANS(cMax)
   set cInputs(pSCA)      $tdsANS(cSca)
   set cInputs(WHITE)     NO
   set cInputs(FMT)       VERTICAL
   set cInputs(POS)       RELATIVE
   set cInputs(ANNOTATE)  YES
   set cInputs(AXIS)      YES
   set cInputs(PRIMARY)   TICMJ:TICMN:NUM:LABEL
   set cInputs(SECONDARY) TICMJ:TICMN:NUM:LABEL
   set cInputs(PSIZE)     HOLD:HOLD:16:16
   set cInputs(PFMTS)     HOLD:HOLD:$nFmt
   set cInputs(LABELS)    ":"
                                                                                

   set cW [ColorBar 1 1.1 0.0 0.0 1.2 0.9 0.0 cInputs cA cB]
   return $cW
}
